/*
 *  Dumper.c
 *  PIDShapeDumper
 *
 *  Created by Alexander Strange on Sat Dec 14 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#import "Dumper.h"
#import "ImageWriter.h"
#import <iostream.h>

void dump_shapes(void *theShapesRsrc, unsigned long rId, unsigned long rsrcSize)
{
    struct collection_header *coll = theShapesRsrc;
    struct high_level_shape_header *hls = offset_of_hls_header(coll,0) + (long)coll;
    struct low_level_shape_header *lls = offset_of_lls_header(coll,0) + (long)coll;
    unsigned long i,j;

    cout << "Number of shapes: " << coll->count << endl
        << "Pixel data size (?): " << coll->pixel_data_size << endl
        << "Color tables/count: " << coll->color_tables << '/' << coll->color_count << endl << endl;

    for (j=0;j<coll->color_tables;j++) {
	for (i=0;i<coll->count;i++)
	{
	    hls = offset_of_hls_header(coll,i) + (long)coll;
	    lls = offset_of_lls_header(coll,i) + (long)coll;

	    cout << "Info on high level header " << i << ':' << endl
		<< "Order: " << hls->type << endl
		<< "Elevation (?): " << hls->elevation << endl << endl;

	    cout << "Info on low level header " << i << ':' << endl
		<< "Pixel data offset: " << lls->pixel_offset << endl
		<< "Width: " << lls->width << endl
		<< "Height: " << lls->height << endl << endl;

	    NSString *file = [NSString stringWithFormat:@"PID_C%lu_S%lu_B%lu.tif",rId,j,i];
	    cout << "Attempting to dump bitmap " << i << " to file " << [file cString] << endl;
	    write_bitmap_to_file(coll,i,file,rsrcSize, j);
	}
    }
}
