/*
 *  Dumper.h
 *  PIDShapeDumper
 *
 *  Created by Alexander Strange on Sat Dec 14 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */
#import <Carbon/Carbon.h>

#pragma options align=mac68k
struct collection_header {
    short count; //number of shapes
    long high_level_offset, low_level_offset, pixel_data_offset, pixel_data_size;
    unsigned char transparent_index;
    short color_tables, color_count;
    CSpecArray colors;
    /* high level shapes */
    /* low level shapes */
    /* pixel data */
};

struct high_level_shape_header {
    short type /* row or column-ordered */, flags;
    short base_shape, window_shape;  /* window_shape == 0 means no window */
    short world_width, world_height;
    short elevation;
    long window_offset;
    Rect window;
    short unused0,unused1,unused2; /*zeroed */
};

struct low_level_shape_header {
    long pixel_offset;
    short width, height;
    short last_window;
    short unused0,unused1,unused2; /*zeroed */
};

inline static unsigned long offset_of_hls_header(struct collection_header * coll, short theId)
{
    return (theId * sizeof(struct high_level_shape_header)) + coll->high_level_offset;
}

inline static unsigned long offset_of_lls_header(struct collection_header * coll, short theId)
{
    return (theId * sizeof(struct low_level_shape_header)) + coll->low_level_offset;
}

inline static unsigned long offset_of_pixel_data(struct collection_header * coll, short theId)
{
    return ((struct low_level_shape_header *)(offset_of_lls_header(coll,theId) + (long)coll))->pixel_offset;
}

extern void dump_shapes(void *theShapesRsrc, unsigned long rId, unsigned long rsrcSize);
#pragma options align=reset
